#import <Cocoa/Cocoa.h>

#import "XeeBitmapImage.h"

@class XeeIFFReader;

@interface XeeILBMImage:XeeBitmapImage
{
	XeeIFFReader *iff;

	int realwidth,realheight;
	int planes,masking,compression,trans;
	int xasp,yasp,xscale,yscale;
	int rowbytes;

	BOOL ham,ham8,ehb,ocscol;

	byte *image;
	byte *mask;

	unsigned long palette[256];

	NSMutableArray *ranges;

	int current_line;

	int clock;
	NSTimer *animationtimer;
}

-(id)initWithFile:(NSString *)name firstBlock:(NSData *)block attributes:(NSDictionary *)attributes;
-(void)dealloc;

-(void)load;
-(BOOL)readRow:(byte *)row;
-(void)renderImage;

-(unsigned long *)palette;

-(BOOL)animated;
-(void)setAnimating:(BOOL)animating;
-(BOOL)animating;

+(NSArray *)fileTypes;

@end


@interface XeeILBMRange:NSObject
{
	int num;
	unsigned long *colours;
	int *indexes;

	float interval;
	float next;

	XeeILBMImage *image;
}

-(id)initWithIFF:(XeeIFFReader *)iff image:(XeeILBMImage *)image;
-(void)dealloc;
-(BOOL)allocBuffers:(int)length;
-(void)setIndexesFrom:(int)start to:(int)end reverse:(BOOL)reverse;
-(void)setup;
-(BOOL)triggerCheck:(float)time;
-(void)cycle;

@end
