#import <Cocoa/Cocoa.h>

#import "XeeBitmapImage.h"



struct pcx_header
{
	byte manufacturer; // Constant Flag, 10 = ZSoft .pcx 
	byte version; // Version information 
	              // 0 = Version 2.5 of PC Paintbrush 
	              // 2 = Version 2.8 w/palette information 
	              // 3 = Version 2.8 w/o palette information 
	              // 4 = PC Paintbrush for Windows(Plus for
	              //     Windows uses Ver 5) 
	              // 5 = Version 3.0 and > of PC Paintbrush
	              //     and PC Paintbrush +, includes
	              //     Publisher's Paintbrush . Includes
	              //     24-bit .PCX files 
	byte encoding; // 1 = .PCX run length encoding 
	byte bitsperpixel; // Number of bits to represent a pixel
	                   // (per Plane) - 1, 2, 4, or 8 
	byte xmin[2]; // Image Dimensions: Xmin,Ymin,Xmax,Ymax 
	byte ymin[2];
	byte xmax[2];
	byte ymax[2];
	byte hdpi[2]; // Horizontal Resolution of image in DPI
	byte vdpi[2]; // Vertical Resolution of image in DPI
	byte colormap[48]; // Color palette setting, see text 
	byte reserved; // Should be set to 0. 
	byte nplanes; // Number of color planes 
	byte bytesperline[2]; // Number of bytes to allocate for a scanline
	                   // plane.  MUST be an EVEN number.  Do NOT
	                   // calculate from Xmax-Xmin. 
	byte paletteinfo[2]; // How to interpret palette- 1 = Color/BW,
	                     // 2 = Grayscale (ignored in PB IV/ IV +) 
	byte hscreensize[2]; // Horizontal screen size in pixels. New field
	                     // found only in PB IV/IV Plus 
	byte vscreensize[2]; // Vertical screen size in pixels. New field
	                     // found only in PB IV/IV Plus 
	byte filler[54]; // Blank to fill out 128 byte header.  Set all
	                 // bytes to 0 
};



@interface XeePCXImage:XeeBitmapImage
{
	FILE *fh;

	struct pcx_header *pcx;
	NSData *header;

	int current_line;
	byte palette[3*256];
}

-(id)initWithFile:(NSString *)name firstBlock:(NSData *)block attributes:(NSDictionary *)attributes;
-(void)dealloc;

-(void)load;

+(NSArray *)fileTypes;

@end
